package cs214.webapp
package client

import org.scalajs.dom

/** A factory for client-side app instances. */
trait ClientApp:
  def appId: AppId
  def uiId: UIId
  def init(instanceId: InstanceId, userId: UserId, endpoint: String, target: dom.Element): ClientAppInstance

/** An instance of a client-side application. */
trait ClientAppInstance:
  def onMessage(msg: util.Try[ujson.Value]): Unit
