package cs214.webapp.client

import scala.concurrent.Future

/** Functions for rendering server messages. */
trait ClientUI[View]:
  /** Renders an alert. */
  protected def displayAlert(msg: String): Unit

  /** Renders a non-fatal error. */
  protected def displayError(msg: String): Unit

  /** Renders a view. */
  protected def displayView(view: View): Unit

  /** Waits for a specified period of time. */
  protected def after(durationMs: Double): Future[Unit]
