package cs214.webapp.client
package graphics

import scala.concurrent.{Future, Promise}

import org.scalajs.dom
import scala.scalajs.js.timers.{setTimeout}
import scala.scalajs.concurrent.JSExecutionContext.Implicits.queue

trait DOMClientUI[View] extends ClientUI[View]:
  /** Optional CSS style sheet to apply to the application page. When
    * overriding, do not forget to append to the parent definition.
    */
  def css: String = ""
  if !css.isEmpty then
    // Add <style> tag in the header of the page
    val styleTag = dom.document.createElement("style")
    styleTag.textContent = css
    dom.document.head.appendChild(styleTag)

  override def displayAlert(msg: String): Unit =
    dom.window.alert(msg)

  override def displayError(msg: String): Unit =
    dom.window.alert(msg)

  /* Like `setTimeout(interval)`, but return a `Future`. */
  override def after(interval: Double): Future[Unit] =
    val pr = Promise[Unit]()
    setTimeout(interval)(pr.success(()))
    pr.future
